Index: binary-improvements/MapRendering/Web/API/GetPlayerList.cs
===================================================================
--- binary-improvements/MapRendering/Web/API/GetPlayerList.cs	(revision 332)
+++ binary-improvements/MapRendering/Web/API/GetPlayerList.cs	(revision 351)
@@ -17,21 +17,21 @@
 #endif
 
-		public override void HandleRequest (HttpListenerRequest req, HttpListenerResponse resp, WebConnection user,
-			int permissionLevel) {
+		public override void HandleRequest (HttpListenerRequest _req, HttpListenerResponse _resp, WebConnection _user,
+			int _permissionLevel) {
 			AdminTools admTools = GameManager.Instance.adminTools;
-			user = user ?? new WebConnection ("", IPAddress.None, 0L);
-
-			bool bViewAll = WebConnection.CanViewAllPlayers (permissionLevel);
+			_user = _user ?? new WebConnection ("", IPAddress.None, 0L);
+
+			bool bViewAll = WebConnection.CanViewAllPlayers (_permissionLevel);
 
 			// TODO: Sort (and filter?) prior to converting to JSON ... hard as how to get the correct column's data? (i.e. column name matches JSON object field names, not source data)
 
 			int rowsPerPage = 25;
-			if (req.QueryString ["rowsperpage"] != null) {
-				int.TryParse (req.QueryString ["rowsperpage"], out rowsPerPage);
+			if (_req.QueryString ["rowsperpage"] != null) {
+				int.TryParse (_req.QueryString ["rowsperpage"], out rowsPerPage);
 			}
 
 			int page = 0;
-			if (req.QueryString ["page"] != null) {
-				int.TryParse (req.QueryString ["page"], out page);
+			if (_req.QueryString ["page"] != null) {
+				int.TryParse (_req.QueryString ["page"], out page);
 			}
 
@@ -55,5 +55,5 @@
 				}
 
-				if (player_steam_ID == user.SteamID || bViewAll) {
+				if (player_steam_ID == _user.SteamID || bViewAll) {
 					JSONObject pos = new JSONObject ();
 					pos.Add ("x", new JSONNumber (p.LastPosition.x));
@@ -93,9 +93,9 @@
 			IEnumerable<JSONObject> list = playerList;
 
-			foreach (string key in req.QueryString.AllKeys) {
+			foreach (string key in _req.QueryString.AllKeys) {
 				if (!string.IsNullOrEmpty (key) && key.StartsWith ("filter[")) {
 					string filterCol = key.Substring (key.IndexOf ('[') + 1);
 					filterCol = filterCol.Substring (0, filterCol.Length - 1);
-					string filterVal = req.QueryString.Get (key).Trim ();
+					string filterVal = _req.QueryString.Get (key).Trim ();
 
 					list = ExecuteFilter (list, filterCol, filterVal);
@@ -105,9 +105,9 @@
 			int totalAfterFilter = list.Count ();
 
-			foreach (string key in req.QueryString.AllKeys) {
+			foreach (string key in _req.QueryString.AllKeys) {
 				if (!string.IsNullOrEmpty (key) && key.StartsWith ("sort[")) {
 					string sortCol = key.Substring (key.IndexOf ('[') + 1);
 					sortCol = sortCol.Substring (0, sortCol.Length - 1);
-					string sortVal = req.QueryString.Get (key);
+					string sortVal = _req.QueryString.Get (key);
 
 					list = ExecuteSort (list, sortCol, sortVal == "0");
@@ -130,10 +130,10 @@
 			result.Add ("players", playersJsResult);
 
-			WriteJSON (resp, result);
+			WriteJSON (_resp, result);
 		}
 
 		private IEnumerable<JSONObject> ExecuteFilter (IEnumerable<JSONObject> _list, string _filterCol,
 			string _filterVal) {
-			if (_list.Count () == 0) {
+			if (!_list.Any()) {
 				return _list;
 			}
@@ -147,5 +147,5 @@
 				if (colType == typeof (JSONBoolean)) {
 					bool value = StringParsers.ParseBool (_filterVal);
-					return _list.Where (line => ((JSONBoolean) line [_filterCol]).GetBool () == value);
+					return _list.Where (_line => ((JSONBoolean) _line [_filterCol]).GetBool () == value);
 				}
 
@@ -157,5 +157,5 @@
 					//Log.Out ("GetPlayerList: Filter on String with Regex '" + _filterVal + "'");
 					Regex matcher = new Regex (_filterVal, RegexOptions.IgnoreCase);
-					return _list.Where (line => matcher.IsMatch (((JSONString) line [_filterCol]).GetString ()));
+					return _list.Where (_line => matcher.IsMatch (((JSONString) _line [_filterCol]).GetString ()));
 				}
 			}
@@ -198,6 +198,6 @@
 				}
 
-				return _list.Where (delegate (JSONObject line) {
-					double objVal = ((JSONNumber) line [_filterCol]).GetDouble ();
+				return _list.Where (delegate (JSONObject _line) {
+					double objVal = ((JSONNumber) _line [_filterCol]).GetDouble ();
 					switch (matchType) {
 						case NumberMatchType.Greater:
@@ -230,23 +230,23 @@
 				if (colType == typeof (JSONNumber)) {
 					if (_ascending) {
-						return _list.OrderBy (line => ((JSONNumber) line [_sortCol]).GetDouble ());
-					}
-
-					return _list.OrderByDescending (line => ((JSONNumber) line [_sortCol]).GetDouble ());
+						return _list.OrderBy (_line => ((JSONNumber) _line [_sortCol]).GetDouble ());
+					}
+
+					return _list.OrderByDescending (_line => ((JSONNumber) _line [_sortCol]).GetDouble ());
 				}
 
 				if (colType == typeof (JSONBoolean)) {
 					if (_ascending) {
-						return _list.OrderBy (line => ((JSONBoolean) line [_sortCol]).GetBool ());
-					}
-
-					return _list.OrderByDescending (line => ((JSONBoolean) line [_sortCol]).GetBool ());
+						return _list.OrderBy (_line => ((JSONBoolean) _line [_sortCol]).GetBool ());
+					}
+
+					return _list.OrderByDescending (_line => ((JSONBoolean) _line [_sortCol]).GetBool ());
 				}
 
 				if (_ascending) {
-					return _list.OrderBy (line => line [_sortCol].ToString ());
-				}
-
-				return _list.OrderByDescending (line => line [_sortCol].ToString ());
+					return _list.OrderBy (_line => _line [_sortCol].ToString ());
+				}
+
+				return _list.OrderByDescending (_line => _line [_sortCol].ToString ());
 			}
 
@@ -255,18 +255,18 @@
 
 
-		private bool NearlyEqual (double a, double b, double epsilon) {
-			double absA = Math.Abs (a);
-			double absB = Math.Abs (b);
-			double diff = Math.Abs (a - b);
-
-			if (a == b) {
+		private bool NearlyEqual (double _a, double _b, double _epsilon) {
+			double absA = Math.Abs (_a);
+			double absB = Math.Abs (_b);
+			double diff = Math.Abs (_a - _b);
+
+			if (_a == _b) {
 				return true;
 			}
 
-			if (a == 0 || b == 0 || diff < double.Epsilon) {
-				return diff < epsilon;
-			}
-
-			return diff / (absA + absB) < epsilon;
+			if (_a == 0 || _b == 0 || diff < double.Epsilon) {
+				return diff < _epsilon;
+			}
+
+			return diff / (absA + absB) < _epsilon;
 		}
 