Index: binary-improvements/AllocsCommands/Commands/ListKnownPlayers.cs
===================================================================
--- binary-improvements/AllocsCommands/Commands/ListKnownPlayers.cs	(revision 332)
+++ binary-improvements/AllocsCommands/Commands/ListKnownPlayers.cs	(revision 359)
@@ -26,61 +26,57 @@
 
 		public override void Execute (List<string> _params, CommandSenderInfo _senderInfo) {
-			try {
-				AdminTools admTools = GameManager.Instance.adminTools;
+			AdminTools admTools = GameManager.Instance.adminTools;
 
-				bool onlineOnly = false;
-				bool notBannedOnly = false;
-				string nameFilter = string.Empty;
-				bool isSteamId = false;
+			bool onlineOnly = false;
+			bool notBannedOnly = false;
+			string nameFilter = string.Empty;
+			bool isSteamId = false;
 
-				if (_params.Count == 1) {
-					long steamid;
-					if (_params [0].EqualsCaseInsensitive ("-online")) {
-						onlineOnly = true;
-					} else if (_params [0].EqualsCaseInsensitive ("-notbanned")) {
-						notBannedOnly = true;
-					} else if (_params [0].Length == 17 && long.TryParse (_params [0], out steamid)) {
-						isSteamId = true;
-					} else {
-						nameFilter = _params [0];
+			if (_params.Count == 1) {
+				long steamid;
+				if (_params [0].EqualsCaseInsensitive ("-online")) {
+					onlineOnly = true;
+				} else if (_params [0].EqualsCaseInsensitive ("-notbanned")) {
+					notBannedOnly = true;
+				} else if (_params [0].Length == 17 && long.TryParse (_params [0], out steamid)) {
+					isSteamId = true;
+				} else {
+					nameFilter = _params [0];
+				}
+			}
+
+			if (isSteamId) {
+				Player p = PersistentContainer.Instance.Players [_params [0], false];
+
+				if (p != null) {
+					SdtdConsole.Instance.Output (string.Format (
+						"{0}. {1}, id={2}, steamid={3}, online={4}, ip={5}, playtime={6} m, seen={7}",
+						0, p.Name, p.EntityID, _params [0], p.IsOnline, p.IP,
+						p.TotalPlayTime / 60,
+						p.LastOnline.ToString ("yyyy-MM-dd HH:mm"))
+					);
+				} else {
+					SdtdConsole.Instance.Output (string.Format ("SteamID {0} unknown!", _params [0]));
+				}
+			} else {
+				int num = 0;
+				foreach (KeyValuePair<string, Player> kvp in PersistentContainer.Instance.Players.Dict) {
+					Player p = kvp.Value;
+
+					if (
+						(!onlineOnly || p.IsOnline)
+						&& (!notBannedOnly || !admTools.IsBanned (kvp.Key))
+						&& (nameFilter.Length == 0 || p.Name.ContainsCaseInsensitive (nameFilter))
+					) {
+						SdtdConsole.Instance.Output (string.Format (
+							"{0}. {1}, id={2}, steamid={3}, online={4}, ip={5}, playtime={6} m, seen={7}",
+							++num, p.Name, p.EntityID, kvp.Key, p.IsOnline, p.IP,
+							p.TotalPlayTime / 60,
+							p.LastOnline.ToString ("yyyy-MM-dd HH:mm"))
+						);
 					}
 				}
 
-				if (isSteamId) {
-					Player p = PersistentContainer.Instance.Players [_params [0], false];
-
-					if (p != null) {
-						SdtdConsole.Instance.Output (string.Format (
-							"{0}. {1}, id={2}, steamid={3}, online={4}, ip={5}, playtime={6} m, seen={7}",
-							0, p.Name, p.EntityID, _params [0], p.IsOnline, p.IP,
-							p.TotalPlayTime / 60,
-							p.LastOnline.ToString ("yyyy-MM-dd HH:mm"))
-						);
-					} else {
-						SdtdConsole.Instance.Output (string.Format ("SteamID {0} unknown!", _params [0]));
-					}
-				} else {
-					int num = 0;
-					foreach (KeyValuePair<string, Player> kvp in PersistentContainer.Instance.Players.Dict) {
-						Player p = kvp.Value;
-
-						if (
-							(!onlineOnly || p.IsOnline)
-							&& (!notBannedOnly || !admTools.IsBanned (kvp.Key))
-							&& (nameFilter.Length == 0 || p.Name.ContainsCaseInsensitive (nameFilter))
-						) {
-							SdtdConsole.Instance.Output (string.Format (
-								"{0}. {1}, id={2}, steamid={3}, online={4}, ip={5}, playtime={6} m, seen={7}",
-								++num, p.Name, p.EntityID, kvp.Key, p.IsOnline, p.IP,
-								p.TotalPlayTime / 60,
-								p.LastOnline.ToString ("yyyy-MM-dd HH:mm"))
-							);
-						}
-					}
-
-					SdtdConsole.Instance.Output ("Total of " + PersistentContainer.Instance.Players.Count + " known");
-				}
-			} catch (Exception e) {
-				Log.Out ("Error in ListKnownPlayers.Run: " + e);
+				SdtdConsole.Instance.Output ("Total of " + PersistentContainer.Instance.Players.Count + " known");
 			}
 		}