Index: binary-improvements2/WebServer/src/WebPermissions.cs
===================================================================
--- binary-improvements2/WebServer/src/WebPermissions.cs	(revision 395)
+++ binary-improvements2/WebServer/src/WebPermissions.cs	(revision 399)
@@ -184,5 +184,5 @@
 
 		private void OnFileChanged (object _source, FileSystemEventArgs _e) {
-			Log.Out ("Reloading " + SettingsFileName);
+			Log.Out ("[Web] [Perms] Reloading " + SettingsFileName);
 			Load ();
 		}
@@ -193,10 +193,10 @@
 
 			if (!File.Exists (SettingsFullPath)) {
-				Log.Out ($"Permissions file '{SettingsFileName}' not found, creating.");
+				Log.Out ($"[Web] [Perms] Permissions file '{SettingsFileName}' not found, creating.");
 				Save ();
 				return;
 			}
 
-			Log.Out ($"Loading permissions file at '{SettingsFullPath}'");
+			Log.Out ($"[Web] [Perms] Loading permissions file at '{SettingsFullPath}'");
 
 			XmlDocument xmlDoc = new XmlDocument ();
@@ -205,5 +205,5 @@
 				xmlDoc.Load (SettingsFullPath);
 			} catch (XmlException e) {
-				Log.Error ("Failed loading permissions file: " + e.Message);
+				Log.Error ("[Web] [Perms] Failed loading permissions file: " + e.Message);
 				return;
 			}
@@ -212,5 +212,5 @@
 
 			if (adminToolsNode == null) {
-				Log.Error ("Failed loading permissions file: No DocumentElement found");
+				Log.Error ("[Web] [Perms] Failed loading permissions file: No DocumentElement found");
 				return;
 			}
@@ -227,5 +227,5 @@
 			}
 
-			Log.Out ("Loading permissions file done.");
+			Log.Out ("[Web] [Perms] Loading permissions file done.");
 		}
 
@@ -237,5 +237,5 @@
 
 				if (subChild.NodeType != XmlNodeType.Element) {
-					Log.Warning ($"Unexpected XML node found in 'admintokens' section: {subChild.OuterXml}");
+					Log.Warning ($"[Web] [Perms] Unexpected XML node found in 'admintokens' section: {subChild.OuterXml}");
 					continue;
 				}
@@ -244,15 +244,15 @@
 
 				if (!lineItem.HasAttribute ("name")) {
-					Log.Warning ($"Ignoring admintoken-entry because of missing 'name' attribute: {subChild.OuterXml}");
+					Log.Warning ($"[Web] [Perms] Ignoring admintoken-entry because of missing 'name' attribute: {subChild.OuterXml}");
 					continue;
 				}
 
 				if (!lineItem.HasAttribute ("token")) {
-					Log.Warning ($"Ignoring admintoken-entry because of missing 'token' attribute: {subChild.OuterXml}");
+					Log.Warning ($"[Web] [Perms] Ignoring admintoken-entry because of missing 'token' attribute: {subChild.OuterXml}");
 					continue;
 				}
 
 				if (!lineItem.HasAttribute ("permission_level")) {
-					Log.Warning ($"Ignoring admintoken-entry because of missing 'permission_level' attribute: {subChild.OuterXml}");
+					Log.Warning ($"[Web] [Perms] Ignoring admintoken-entry because of missing 'permission_level' attribute: {subChild.OuterXml}");
 					continue;
 				}
@@ -262,5 +262,5 @@
 				if (!int.TryParse (lineItem.GetAttribute ("permission_level"), out int permissionLevel)) {
 					Log.Warning (
-						$"Ignoring admintoken-entry because of invalid (non-numeric) value for 'permission_level' attribute: {subChild.OuterXml}");
+						$"[Web] [Perms] Ignoring admintoken-entry because of invalid (non-numeric) value for 'permission_level' attribute: {subChild.OuterXml}");
 					continue;
 				}
@@ -277,5 +277,5 @@
 
 				if (subChild.NodeType != XmlNodeType.Element) {
-					Log.Warning ($"Unexpected XML node found in 'permissions' section: {subChild.OuterXml}");
+					Log.Warning ($"[Web] [Perms] Unexpected XML node found in 'permissions' section: {subChild.OuterXml}");
 					continue;
 				}
@@ -284,10 +284,10 @@
 
 				if (!lineItem.HasAttribute ("module")) {
-					Log.Warning ($"Ignoring permission-entry because of missing 'module' attribute: {subChild.OuterXml}");
+					Log.Warning ($"[Web] [Perms] Ignoring permission-entry because of missing 'module' attribute: {subChild.OuterXml}");
 					continue;
 				}
 
 				if (!lineItem.HasAttribute ("permission_level")) {
-					Log.Warning ($"Ignoring permission-entry because of missing 'permission_level' attribute: {subChild.OuterXml}");
+					Log.Warning ($"[Web] [Perms] Ignoring permission-entry because of missing 'permission_level' attribute: {subChild.OuterXml}");
 					continue;
 				}
@@ -295,5 +295,5 @@
 				if (!int.TryParse (lineItem.GetAttribute ("permission_level"), out int permissionLevel)) {
 					Log.Warning (
-						$"Ignoring permission-entry because of invalid (non-numeric) value for 'permission_level' attribute: {subChild.OuterXml}");
+						$"[Web] [Perms] Ignoring permission-entry because of invalid (non-numeric) value for 'permission_level' attribute: {subChild.OuterXml}");
 					continue;
 				}