Index: binary-improvements/MapRendering/WebAndMapRendering.csproj
===================================================================
--- binary-improvements/MapRendering/WebAndMapRendering.csproj	(revision 450)
+++ binary-improvements/MapRendering/WebAndMapRendering.csproj	(revision 454)
@@ -11,4 +11,6 @@
     <AssemblyName>AllocsWeb</AssemblyName>
     <TargetFrameworkVersion>v4.8</TargetFrameworkVersion>
+    <Nullable>warnings</Nullable>
+    <LangVersion>9</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -55,4 +57,8 @@
       <Private>False</Private>
     </Reference>
+    <Reference Include="SpaceWizards.HttpListener">
+      <HintPath>..\7dtd-binaries\SpaceWizards.HttpListener.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
     <Reference Include="UnityEngine">
       <HintPath>..\7dtd-binaries\UnityEngine.dll</HintPath>
@@ -89,44 +95,23 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="API\ExecuteConsoleCommand.cs" />
+    <Compile Include="API\GetAllowedCommands.cs" />
+    <Compile Include="API\GetAnimalsLocation.cs" />
+    <Compile Include="API\GetHostileLocation.cs" />
+    <Compile Include="API\GetLandClaims.cs" />
+    <Compile Include="API\GetLog.cs" />
+    <Compile Include="API\GetPlayerInventories.cs" />
+    <Compile Include="API\GetPlayerInventory.cs" />
+    <Compile Include="API\GetPlayerList.cs" />
+    <Compile Include="API\GetPlayersLocation.cs" />
+    <Compile Include="API\GetPlayersOnline.cs" />
+    <Compile Include="API\GetServerInfo.cs" />
+    <Compile Include="API\GetStats.cs" />
+    <Compile Include="API\GetWebUIUpdates.cs" />
     <Compile Include="AssemblyInfo.cs" />
     <Compile Include="API.cs" />
-    <Compile Include="Web\API\GetAnimalsLocation.cs" />
-    <Compile Include="Web\API\GetHostileLocation.cs" />
-    <Compile Include="Web\API\Null.cs" />
-    <Compile Include="Web\SSE\EventLog.cs" />
-    <Compile Include="Web\SSE\SseHandler.cs" />
-    <Compile Include="Web\SSE\EventBase.cs" />
-    <Compile Include="Web\Web.cs" />
-    <Compile Include="Web\MimeType.cs" />
-    <Compile Include="Web\API\GetPlayersOnline.cs" />
-    <Compile Include="Web\API\WebAPI.cs" />
-    <Compile Include="Web\API\GetPlayersLocation.cs" />
-    <Compile Include="Web\API\GetPlayerInventory.cs" />
-    <Compile Include="Web\API\GetLandClaims.cs" />
-    <Compile Include="Commands\webstat.cs" />
-    <Compile Include="Web\API\GetStats.cs" />
-    <Compile Include="Web\WebConnection.cs" />
-    <Compile Include="Web\OpenID.cs" />
-    <Compile Include="Web\ConnectionHandler.cs" />
-    <Compile Include="Web\WebPermissions.cs" />
-    <Compile Include="Web\Handlers\ApiHandler.cs" />
-    <Compile Include="Web\Handlers\ItemIconHandler.cs" />
-    <Compile Include="Web\Handlers\PathHandler.cs" />
-    <Compile Include="Web\Handlers\SimpleRedirectHandler.cs" />
-    <Compile Include="Web\Handlers\StaticHandler.cs" />
-    <Compile Include="Web\Handlers\SessionHandler.cs" />
-    <Compile Include="Web\API\ExecuteConsoleCommand.cs" />
-    <Compile Include="Commands\ReloadWebPermissions.cs" />
-    <Compile Include="Web\Handlers\UserStatusHandler.cs" />
-    <Compile Include="Commands\WebTokens.cs" />
-    <Compile Include="Commands\WebPermissionsCmd.cs" />
-    <Compile Include="Web\LogBuffer.cs" />
-    <Compile Include="Web\API\GetLog.cs" />
-    <Compile Include="Web\API\GetWebUIUpdates.cs" />
-    <Compile Include="Web\API\GetServerInfo.cs" />
-    <Compile Include="Web\API\GetPlayerList.cs" />
-    <Compile Include="Web\WebCommandResult.cs" />
-    <Compile Include="Web\API\GetAllowedCommands.cs" />
-    <Compile Include="Web\API\GetPlayerInventories.cs" />
+    <Compile Include="LegacyApiHelper.cs" />
+    <Compile Include="SteamLoginApi.cs" />
+    <Compile Include="WebCommandResult.cs" />
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
@@ -142,10 +127,4 @@
       <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
     </None>
-    <None Include="steam-intermediate.cer">
-      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
-    </None>
-    <None Include="steam-rootca.cer">
-      <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
-    </None>
   </ItemGroup>
 </Project>